"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomActionBuilder = void 0;
var util_1 = require("../../util");
var custom_action_interface_1 = require("./custom-action.interface");
var definitions_interface_1 = require("../../definitions.interface");
var CustomActionBuilder = /** @class */ (function () {
    function CustomActionBuilder() {
    }
    /**
     * @stable [22.10.2018]
     * @param {string} section
     * @param {string} type
     * @returns {string}
     */
    CustomActionBuilder.buildCustomActionType = function (section, type) {
        return util_1.orNull(section, "" + definitions_interface_1.ACTION_PREFIX + section + "." + type);
    };
    /**
     * @stable [22.10.2018]
     * @param {string} section
     * @returns {string}
     */
    CustomActionBuilder.buildCustomCloneActionType = function (section) {
        return this.buildCustomActionType(section, custom_action_interface_1.CUSTOM_ACTION_CLONE_ACTION_TYPE);
    };
    /**
     * @stable [22.10.2018]
     * @param {string} section
     * @returns {string}
     */
    CustomActionBuilder.buildCustomDisableActionType = function (section) {
        return this.buildCustomActionType(section, custom_action_interface_1.CUSTOM_ACTION_DISABLE_ACTION_TYPE);
    };
    /**
     * @stable [22.10.2018]
     * @param {string} section
     * @returns {string}
     */
    CustomActionBuilder.buildCustomDeleteActionType = function (section) {
        return this.buildCustomActionType(section, custom_action_interface_1.CUSTOM_ACTION_DELETE_ACTION_TYPE);
    };
    return CustomActionBuilder;
}());
exports.CustomActionBuilder = CustomActionBuilder;
//# sourceMappingURL=custom-action.builder.js.map