"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterActionBuilder = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var util_1 = require("../util");
var definition_1 = require("../definition");
/**
 * @action-builder
 * @stable [08.09.2020]
 */
var FilterActionBuilder = /** @class */ (function () {
    function FilterActionBuilder() {
    }
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterActionBuilder.buildApplyActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.FILTER_APPLY_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterActionBuilder.buildChangeActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.FILTER_CHANGE_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterActionBuilder.buildDeactivateActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.FILTER_DEACTIVATE_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterActionBuilder.buildActivateActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.FILTER_ACTIVATE_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterActionBuilder.buildDestroyActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.FILTER_DESTROY_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterActionBuilder.buildApplyPlainAction = function (section) {
        return { type: this.buildApplyActionType(section), data: util_1.SectionUtils.applySection(section) };
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterActionBuilder.buildActivatePlainAction = function (section) {
        return { type: this.buildActivateActionType(section), data: util_1.SectionUtils.applySection(section) };
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterActionBuilder.buildDeactivatePlainAction = function (section) {
        return { type: this.buildDeactivateActionType(section), data: util_1.SectionUtils.applySection(section) };
    };
    /**
     * @stable [08.09.2020]
     * @param section
     * @param query
     */
    FilterActionBuilder.buildChangePlainAction = function (section, query) {
        var fluxEntity = { query: query };
        return { type: this.buildChangeActionType(section), data: util_1.SectionUtils.applySection(section, fluxEntity) };
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterActionBuilder.buildDestroyPlainAction = function (section) {
        return { type: this.buildDestroyActionType(section), data: util_1.SectionUtils.applySection(section) };
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterActionBuilder.buildDestroyAction = function (section) {
        var plainAction = this.buildDestroyPlainAction(section);
        return redux_effects_promise_1.EffectsAction.create(plainAction.type, plainAction.data);
    };
    return FilterActionBuilder;
}());
exports.FilterActionBuilder = FilterActionBuilder;
//# sourceMappingURL=filter-action.builder.js.map