"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotificationActionBuilder = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var definition_1 = require("../definition");
var util_1 = require("../util");
var NotificationActionBuilder = /** @class */ (function () {
    function NotificationActionBuilder() {
    }
    /**
     * @stable [13.02.2020]
     * @param {string | IEffectsAction} error
     * @returns {IEffectsAction}
     */
    NotificationActionBuilder.buildErrorAction = function (error) {
        var plainAction = this.buildPlainErrorAction(error);
        return redux_effects_promise_1.EffectsAction.create(plainAction.type, plainAction.data);
    };
    /**
     * @stable [13.02.2020]
     * @param {string} info
     * @returns {IEffectsAction}
     */
    NotificationActionBuilder.buildInfoAction = function (info) {
        var plainAction = this.buildPlainInfoAction(info);
        return redux_effects_promise_1.EffectsAction.create(plainAction.type, plainAction.data);
    };
    /**
     * @stable [13.02.2020]
     * @param {string} info
     * @returns {IEffectsAction}
     */
    NotificationActionBuilder.buildPlainInfoAction = function (info) {
        var notificationEntity = { info: info };
        return { type: definition_1.$_RAC_NOTIFICATION_INFO_ACTION_TYPE, data: notificationEntity };
    };
    /**
     * @stable [13.02.2020]
     * @param {string | IEffectsAction} error
     * @returns {IEffectsAction}
     */
    NotificationActionBuilder.buildPlainErrorAction = function (error) {
        var notificationEntity = {
            error: util_1.TypeUtils.isString(error)
                ? error
                : util_1.Selectors.error(error),
        };
        return { type: definition_1.$_RAC_NOTIFICATION_ERROR_ACTION_TYPE, data: notificationEntity };
    };
    /**
     * @stable [13.02.2020]
     * @returns {IEffectsAction}
     */
    NotificationActionBuilder.buildPlainClearAction = function () {
        return { type: definition_1.$_RAC_NOTIFICATION_CLEAR_ACTION_TYPE };
    };
    return NotificationActionBuilder;
}());
exports.NotificationActionBuilder = NotificationActionBuilder;
//# sourceMappingURL=notification-action.builder.js.map