"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RouterActionBuilder = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var definition_1 = require("../definition");
var RouterActionBuilder = /** @class */ (function () {
    function RouterActionBuilder() {
    }
    /**
     * @stable [18.12.2019]
     * @param {number} depth
     * @returns {IEffectsAction}
     */
    RouterActionBuilder.buildNavigateBackPlainAction = function (depth) {
        var payload = { depth: depth };
        return { type: definition_1.$RAC_ROUTER_NAVIGATE_BACK_ACTION_TYPE, data: payload };
    };
    /**
     * @stable [06.02.2020]
     * @param {string} path
     * @returns {IEffectsAction}
     */
    RouterActionBuilder.buildNavigatePlainAction = function (path) {
        return { type: definition_1.$RAC_ROUTER_NAVIGATE_ACTION_TYPE, data: path };
    };
    /**
     * @stable [30.03.2020]
     * @param {string} path
     * @returns {IEffectsAction}
     */
    RouterActionBuilder.buildRewritePlainAction = function (path) {
        return { type: definition_1.$RAC_ROUTER_REWRITE_ACTION_TYPE, data: path };
    };
    /**
     * @stable [03.06.2018]
     * @param {string} path
     * @returns {IEffectsAction}
     */
    RouterActionBuilder.buildNavigateAction = function (path) {
        var plainAction = this.buildNavigatePlainAction(path);
        return redux_effects_promise_1.EffectsAction.create(plainAction.type, plainAction.data);
    };
    /**
     * @stable [30.03.2020]
     * @param {string} path
     * @returns {IEffectsAction}
     */
    RouterActionBuilder.buildRewriteAction = function (path) {
        var plainAction = this.buildRewritePlainAction(path);
        return redux_effects_promise_1.EffectsAction.create(plainAction.type, plainAction.data);
    };
    /**
     * @stable [17.11.2019]
     * @param {string} path
     * @returns {IEffectsAction}
     */
    RouterActionBuilder.buildReplaceAction = function (path) {
        return redux_effects_promise_1.EffectsAction.create(definition_1.$RAC_ROUTER_REPLACE_ACTION_TYPE, path);
    };
    /**
     * @stable [17.11.2019]
     * @returns {IEffectsAction}
     */
    RouterActionBuilder.buildBackAction = function () {
        return redux_effects_promise_1.EffectsAction.create(definition_1.$RAC_ROUTER_NAVIGATE_BACK_ACTION_TYPE);
    };
    /**
     * @stable [17.11.2019]
     * @returns {IEffectsAction}
     */
    RouterActionBuilder.buildReloadAction = function () {
        return redux_effects_promise_1.EffectsAction.create(definition_1.$RAC_ROUTER_RELOAD_ACTION_TYPE);
    };
    return RouterActionBuilder;
}());
exports.RouterActionBuilder = RouterActionBuilder;
//# sourceMappingURL=router-action.builder.js.map