"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TabPanelActionBuilder = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var definition_1 = require("../definition");
var util_1 = require("../util");
/**
 * @action-builder
 * @stable [08.09.2020]
 */
var TabPanelActionBuilder = /** @class */ (function () {
    function TabPanelActionBuilder() {
    }
    /**
     * @stable [08.09.2020]
     * @param section
     */
    TabPanelActionBuilder.buildActiveValueActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.TAB_PANEL_ACTIVE_VALUE_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    TabPanelActionBuilder.buildInactiveValueActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.TAB_PANEL_INACTIVE_VALUE_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    TabPanelActionBuilder.buildDestroyActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.TAB_PANEL_DESTROY_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    TabPanelActionBuilder.buildDestroyPlainAction = function (section) {
        return { type: this.buildDestroyActionType(section), data: util_1.SectionUtils.applySection(section) };
    };
    /**
     * @stable [08.09.2020]
     * @param section
     * @param payload
     */
    TabPanelActionBuilder.buildActiveValuePlainAction = function (section, payload) {
        return { type: this.buildActiveValueActionType(section), data: util_1.SectionUtils.applySection(section, payload) };
    };
    /**
     * @stable [08.09.2020]
     * @param section
     * @param payload
     */
    TabPanelActionBuilder.buildInactiveValuePlainAction = function (section, payload) {
        return { type: this.buildInactiveValueActionType(section), data: util_1.SectionUtils.applySection(section, payload) };
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    TabPanelActionBuilder.buildDestroyAction = function (section) {
        var plainAction = this.buildDestroyPlainAction(section);
        return redux_effects_promise_1.EffectsAction.create(plainAction.type, plainAction.data);
    };
    return TabPanelActionBuilder;
}());
exports.TabPanelActionBuilder = TabPanelActionBuilder;
//# sourceMappingURL=tab-panel-action.builder.js.map