"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModifyEntityFactory = void 0;
var inversify_1 = require("inversify");
var ts_smart_logger_1 = require("ts-smart-logger");
var util_1 = require("../../util");
var definition_1 = require("../../definition");
var ModifyEntityFactory = /** @class */ (function () {
    function ModifyEntityFactory() {
    }
    ModifyEntityFactory_1 = ModifyEntityFactory;
    /**
     * @stable [23.09.2020]
     * @param action
     */
    ModifyEntityFactory.prototype.makeInstance = function (action) {
        var _a = action.initialData, entityId = _a.entityId, changes = _a.changes;
        var responseEntity = action.data;
        var isResponseDataObject = util_1.TypeUtils.isObject(responseEntity);
        var result = {
            id: isResponseDataObject
                ? responseEntity.id
                : entityId,
            mergeStrategy: isResponseDataObject
                ? definition_1.EntityMergeStrategiesEnum.OVERRIDE
                : definition_1.EntityMergeStrategiesEnum.MERGE,
            changes: isResponseDataObject
                ? responseEntity
                : changes,
        };
        ModifyEntityFactory_1.logger.debug('[$ModifyEntityFactory][makeInstance] Entity:', result, ', action:', action);
        return result;
    };
    var ModifyEntityFactory_1;
    ModifyEntityFactory.logger = ts_smart_logger_1.LoggerFactory.makeLogger('ModifyEntityFactory');
    ModifyEntityFactory = ModifyEntityFactory_1 = __decorate([
        inversify_1.injectable()
    ], ModifyEntityFactory);
    return ModifyEntityFactory;
}());
exports.ModifyEntityFactory = ModifyEntityFactory;
//# sourceMappingURL=modify-entity.factory.js.map