"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.asyncLibReducer = void 0;
var definition_1 = require("../definition");
/**
 * @stable [08.01.2020]
 * @param {IReduxAsyncLibsEntity} state
 * @param {AnyAction} action
 * @returns {IReduxAsyncLibsEntity}
 */
exports.asyncLibReducer = function (state, action) {
    var _a, _b;
    if (state === void 0) { state = definition_1.INITIAL_REDUX_ASYNC_LIBS_ENTITY; }
    var actionData = action.data;
    switch (action.type) {
        case definition_1.$RAC_ASYNC_LIB_LOAD_ACTION_TYPE:
            return __assign(__assign({}, state), (_a = {}, _a[actionData.alias] = {
                data: false,
                loading: true,
            }, _a));
        case definition_1.$RAC_ASYNC_LIB_LOAD_DONE_ACTION_TYPE:
            return __assign(__assign({}, state), (_b = {}, _b[actionData.alias] = {
                data: true,
                loading: false,
            }, _b));
    }
    return state;
};
//# sourceMappingURL=async-lib.reducer.js.map