import { IAsyncLibConfigEntity, IBootstrapper } from '../../definition';
export declare class WebBootstrapper implements IBootstrapper {
    private readonly asyncLibManager;
    private readonly domAccessor;
    private readonly environment;
    private readonly eventManager;
    private readonly settings;
    private readonly uiFactory;
    private readonly asyncLibraries;
    /**
     * @stable [09.01.2020]
     */
    constructor();
    /**
     * @stable [09.01.2020]
     * @param {IAsyncLibConfigEntity} cfg
     * @returns {IBootstrapper}
     */
    registerAsyncLibrary(cfg: IAsyncLibConfigEntity): IBootstrapper;
    /**
     * @stable [01.10.2019]
     * @param {() => void} callback
     */
    init(callback: (() => void)): void;
    /**
     * @stable [01.10.2019]
     */
    protected addRootElement(): void;
    /**
     * @stable [01.10.2019]
     */
    protected initGA(): void;
    /**
     * @stable [09.01.2020]
     */
    protected initAsyncLibraries(): void;
    /**
     * @stable [01.10.2019]
     */
    protected applyClasses(): void;
    /**
     * @stable [01.10.2019]
     * @param args
     */
    private gtag;
    /**
     * @stable [@stable [01.10.2019]]
     * @returns {IBootstrapSettings}
     */
    private get bSettings();
    /**
     * @stable [01.10.2019]
     * @returns {Window}
     */
    private get window();
}
