"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApplicationActionBuilder = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var application_interface_1 = require("./application.interface");
var definition_1 = require("../../definition");
// TODO Move
var ApplicationActionBuilder = /** @class */ (function () {
    function ApplicationActionBuilder() {
    }
    /**
     * @stable [28.11.2019]
     * @param {string} error
     * @returns {IEffectsAction}
     */
    ApplicationActionBuilder.buildCustomErrorAction = function (error) {
        return redux_effects_promise_1.EffectsAction.create(definition_1.$RAC_APPLICATION_CUSTOM_ERROR_ACTION_TYPE).setError(error);
    };
    /**
     * @stable [18.11.2019]
     * @returns {IEffectsAction}
     */
    ApplicationActionBuilder.buildPrepareAction = function () {
        return redux_effects_promise_1.EffectsAction.create(definition_1.$RAC_APPLICATION_PREPARE_ACTION_TYPE);
    };
    /**
     * @stable [18.11.2019]
     * @returns {IEffectsAction}
     */
    ApplicationActionBuilder.buildReadyAction = function () {
        return redux_effects_promise_1.EffectsAction.create(definition_1.$RAC_APPLICATION_READY_ACTION_TYPE);
    };
    /**
     * @stable [18.11.2019]
     * @returns {IEffectsAction}
     */
    ApplicationActionBuilder.buildNotReadyAction = function () {
        return redux_effects_promise_1.EffectsAction.create(definition_1.$RAC_APPLICATION_NOT_READY_ACTION_TYPE);
    };
    /**
     * @stable [16.03.2020]
     * @param {IApplicationTokenFluxEntity} payload
     * @returns {IEffectsAction}
     */
    ApplicationActionBuilder.buildAfterLoginAction = function (payload) {
        return redux_effects_promise_1.EffectsAction.create(this.buildAfterLoginActionType(), payload);
    };
    /**
     * @stable [16.03.2020]
     * @param {IApplicationTokenFluxEntity} payload
     * @returns {IEffectsAction}
     */
    ApplicationActionBuilder.buildAuthorizedAction = function (payload) {
        return redux_effects_promise_1.EffectsAction.create(this.buildAuthorizedActionType(), payload);
    };
    ApplicationActionBuilder.buildUnauthorizedAction = function () {
        return redux_effects_promise_1.EffectsAction.create(this.buildUnauthorizedActionType());
    };
    ApplicationActionBuilder.buildAfterLogoutAction = function () {
        return redux_effects_promise_1.EffectsAction.create(this.buildAfterLogoutActionType());
    };
    ApplicationActionBuilder.buildAfterInitAction = function () {
        return redux_effects_promise_1.EffectsAction.create(this.buildAfterInitActionType());
    };
    /**
     * @stable [23.10.2018]
     * @returns {string}
     */
    ApplicationActionBuilder.buildPathActionType = function () {
        return definition_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_PATH_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildAuthorizedActionType = function () {
        return definition_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_AUTHORIZED_ACTION_TYPE;
    };
    /**
     * @stable [17.11.2019]
     * @returns {string}
     */
    ApplicationActionBuilder.buildUnauthorizedActionType = function () {
        return definition_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_UNAUTHORIZED_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildInitActionType = function () {
        return definition_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_INIT_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildAfterInitActionType = function () {
        return definition_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_AFTER_INIT_ACTION_TYPE;
    };
    /**
     * @stable [17.11.2019]
     * @returns {string}
     */
    ApplicationActionBuilder.buildLogoutActionType = function () {
        return definition_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_LOGOUT_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildMountActionType = function () {
        return definition_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_MOUNT_ACTION_TYPE;
    };
    /**
     * @stable [17.11.2019]
     * @returns {string}
     */
    ApplicationActionBuilder.buildAfterLogoutActionType = function () {
        return definition_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_AFTER_LOGOUT_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildAfterLoginActionType = function () {
        return definition_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_AFTER_LOGIN_ACTION_TYPE;
    };
    return ApplicationActionBuilder;
}());
exports.ApplicationActionBuilder = ApplicationActionBuilder;
//# sourceMappingURL=application-action.builder.js.map