"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeApplicationRootContainerCtor = void 0;
var React = require("react");
var react_redux_1 = require("react-redux");
var di_1 = require("../../di");
var application_action_builder_1 = require("./application-action.builder");
var generic_container_1 = require("../base/generic.container");
var connector_factory_1 = require("../connector/connector.factory");
/**
 * @stable [17.06.2020]
 * @param {IGenericContainerCtor} container
 * @param {IGenericContainerProps} initialProps
 * @returns {IGenericContainerCtor}
 */
exports.makeApplicationRootContainerCtor = function (container, initialProps) {
    var Component = connector_factory_1.connectorFactory(container, function (state) { return (__assign({}, state.application)); });
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        /**
         * @stable [08.06.2020]
         * @param {IGenericContainerProps} props
         */
        function class_1(props) {
            var _this = _super.call(this, props) || this;
            // We should dispatch the init action necessarily before the application instantiating
            // because of async App Ready State & Flux architecture
            _this.storeProxy.dispatchActionByType(application_action_builder_1.ApplicationActionBuilder.buildInitActionType());
            return _this;
        }
        /**
         * @stable [08.06.2020]
         * @returns {JSX.Element}
         */
        class_1.prototype.render = function () {
            return (React.createElement(react_redux_1.Provider, { store: di_1.DiServices.store() },
                React.createElement(Component, __assign({}, initialProps))));
        };
        return class_1;
    }(generic_container_1.GenericContainer));
};
//# sourceMappingURL=application-root-container-ctor.factory.js.map