/// <reference types="react" />
import { DictionaryStoreProxyFactoryT, FormStoreProxyFactoryT, IControlledFieldConfigEntity, IControlledFieldItemEntity, IControlledMappedFieldEntity } from '../../definition';
import { IFieldProps2 } from '../../configurations-definitions.interface';
export declare class ControlledFieldFactory<TConfig extends IControlledFieldConfigEntity<TControlledFieldItemEntity, TControlledFieldItemsEnum>, TControlledFieldItemEntity extends IControlledFieldItemEntity<TControlledFieldItemsEnum>, TControlledFieldItemsEnum> {
    protected readonly $dictionaryStoreProxyFactory: DictionaryStoreProxyFactoryT;
    protected readonly $formStoreProxyFactory: FormStoreProxyFactoryT;
    protected readonly fields: Map<TControlledFieldItemsEnum, JSX.Element>;
    /**
     * @stable [11.01.2020]
     * @param {TConfig} config
     * @returns {JSX.Element}
     */
    buildField(config: TConfig): JSX.Element;
    /**
     * @stable [06.04.2020]
     * @param {TConfig} cfg
     * @returns {JSX.Element[]}
     */
    buildFields(cfg: TConfig): JSX.Element[];
    /**
     * @stable [06.04.2020]
     * @param {TConfig} cfg
     * @returns {Array<IControlledMappedFieldEntity<TControlledFieldItemsEnum>>}
     */
    buildMappedFields(cfg: TConfig): Array<IControlledMappedFieldEntity<TControlledFieldItemsEnum>>;
    /**
     * @stable [11.01.2020]
     * @param {IControlledFieldConfigEntity<TControlledFieldItemEntity extends IControlledFieldItemEntity<TControlledFieldItemsEnum>, TControlledFieldItemsEnum>} config
     * @returns {Array<IControlledFieldItemEntity<TControlledFieldItemsEnum>>}
     */
    protected getFields(config: IControlledFieldConfigEntity<TControlledFieldItemEntity, TControlledFieldItemsEnum>): Array<IControlledFieldItemEntity<TControlledFieldItemsEnum>>;
    /**
     * @stable [11.01.2020]
     * @param {TControlledFieldItemEntity[]} fields
     * @returns {TControlledFieldItemEntity[]}
     */
    protected sortFields(fields: TControlledFieldItemEntity[]): TControlledFieldItemEntity[];
    /**
     * @stable [11.01.2020]
     * @param {TConfig} config
     * @param {IControlledFieldItemEntity<TControlledFieldItemsEnum, IFieldProps2>} actualFieldCfg
     * @param {Array<IControlledFieldItemEntity<TControlledFieldItemsEnum>>} actualFields
     * @returns {IFieldProps2}
     */
    protected getExtraProps(config: TConfig, actualFieldCfg: IControlledFieldItemEntity<TControlledFieldItemsEnum, IFieldProps2>, actualFields: Array<IControlledFieldItemEntity<TControlledFieldItemsEnum>>): IFieldProps2;
}
