"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UniversalField = void 0;
var Printf = require("sprintf-js");
var ts_smart_logger_1 = require("ts-smart-logger");
var util_1 = require("../../../util");
var definition_1 = require("../../../definition");
var field_component_1 = require("./field.component");
var UniversalField = /** @class */ (function (_super) {
    __extends(UniversalField, _super);
    /**
     * @stable [17.06.2018]
     * @param {TProps} props
     */
    function UniversalField(props) {
        var _this = _super.call(this, props) || this;
        _this.onChange = _this.onChange.bind(_this);
        _this.onBlur = _this.onBlur.bind(_this);
        _this.onKeyUp = _this.onKeyUp.bind(_this);
        _this.onKeyDown = _this.onKeyDown.bind(_this);
        return _this;
    }
    /**
     * @stable [18.06.2018]
     * @param {IKeyboardEvent} event
     */
    UniversalField.prototype.onKeyBackspace = function (event) {
        var props = this.props;
        if (util_1.isFn(props.onKeyBackspace)) {
            props.onKeyBackspace(event);
        }
    };
    /**
     * @stable [18.06.2018]
     * @param {IKeyboardEvent} event
     */
    UniversalField.prototype.onKeyUp = function (event) {
        var props = this.props;
        if (util_1.isFn(props.onKeyUp)) {
            props.onKeyUp(event);
        }
    };
    /**
     * @stable [03.09.2018]
     * @param {IKeyboardEvent} event
     */
    UniversalField.prototype.onKeyDown = function (event) {
        var props = this.props;
        if (util_1.isFn(props.onKeyDown)) {
            props.onKeyDown(event);
        }
    };
    /**
     * @stable [04.09.2018]
     * @param {IKeyboardEvent} event
     */
    UniversalField.prototype.onKeyTab = function (event) {
        var props = this.props;
        if (util_1.isFn(props.onKeyTab)) {
            props.onKeyTab(event);
        }
    };
    /**
     * @stable [11.01.2020]
     * @param {IBaseEvent} event
     */
    UniversalField.prototype.onKeyEscape = function (event) {
        var props = this.props;
        if (util_1.isFn(props.onKeyEscape)) {
            props.onKeyEscape(event);
        }
    };
    /**
     * @stable [18.06.2018]
     * @param {IKeyboardEvent} event
     */
    UniversalField.prototype.onKeyArrowDown = function (event) {
        var props = this.props;
        if (util_1.isFn(props.onKeyArrowDown)) {
            props.onKeyArrowDown(event);
        }
    };
    /**
     * @stable [18.06.2018]
     * @param {IKeyboardEvent} event
     */
    UniversalField.prototype.onKeyArrowUp = function (event) {
        var props = this.props;
        if (util_1.isFn(props.onKeyArrowUp)) {
            props.onKeyArrowUp(event);
        }
    };
    /**
     * @stable [29.10.2019]
     * @param {boolean} usePrintf
     * @param {AnyT} args
     * @returns {string}
     */
    UniversalField.prototype.buildDisplayMessage = function (usePrintf) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return usePrintf
            ? Printf.sprintf.apply(Printf, __spreadArrays([this.t(this.props.displayMessage)], args)) : definition_1.FieldConstants.DISPLAY_EMPTY_VALUE;
    };
    /**
     * @stable [17.06.2018]
     * @returns {string}
     */
    UniversalField.prototype.getFieldPattern = function () {
        return this.props.pattern;
    };
    /**
     * @stable [30.10.2019]
     * @param {IFocusEvent} event
     */
    UniversalField.prototype.onBlur = function (event) {
        this.setState({ focused: false });
        var props = this.props;
        if (util_1.isFn(props.onBlur)) {
            props.onBlur(event);
        }
    };
    UniversalField.logger = ts_smart_logger_1.LoggerFactory.makeLogger('UniversalField');
    UniversalField.defaultProps = util_1.PropsUtils.mergeWithParentDefaultProps({}, field_component_1.Field);
    return UniversalField;
}(field_component_1.Field));
exports.UniversalField = UniversalField;
//# sourceMappingURL=universal-field.component.js.map