"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberField = void 0;
var util_1 = require("../../../util");
var base_text_field_component_1 = require("../text-field/base-text-field.component");
var keyboard_1 = require("../../keyboard");
var NumberField = /** @class */ (function (_super) {
    __extends(NumberField, _super);
    function NumberField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NumberField.prototype.getRawValueFromEvent = function (event) {
        return this.nc.number(_super.prototype.getRawValueFromEvent.call(this, event));
    };
    NumberField.prototype.getFieldPattern = function () {
        return _super.prototype.getFieldPattern.call(this) || this.numberSettings.uiPattern;
    };
    Object.defineProperty(NumberField.prototype, "numberSettings", {
        get: function () {
            return this.settings.number || {};
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @stable [01.02.2020]
     * @returns {IKeyboardProps}
     */
    NumberField.prototype.getKeyboardProps = function () {
        return __assign({ layout: [keyboard_1.KEYBOARD_NUMERIC_LAYOUT] }, _super.prototype.getKeyboardProps.call(this));
    };
    /**
     * @stable [02.05.2019]
     * @returns {string}
     */
    NumberField.prototype.getFieldClassName = function () {
        return util_1.toClassName(_super.prototype.getFieldClassName.call(this), 'rac-number-field');
    };
    NumberField.defaultProps = util_1.PropsUtils.mergeWithParentDefaultProps({
        clearActionRendered: false,
    }, base_text_field_component_1.BaseTextField);
    return NumberField;
}(base_text_field_component_1.BaseTextField));
exports.NumberField = NumberField;
//# sourceMappingURL=numberfield.component.js.map