/// <reference types="react" />
import { BaseSelect } from '../select/base-select.component';
import { IPlaceFieldProps, IPlaceFieldState, IPlaceSelectOptionEntity, PlaceEntityValueT } from '../../../definition';
export declare class PlaceField extends BaseSelect<IPlaceFieldProps, IPlaceFieldState> {
    static readonly defaultProps: IPlaceFieldProps & Partial<import("../../../definition").IGenericComponentProps<any>>;
    private static readonly PLACE_MARKER;
    private readonly dialogRef;
    private readonly googleMapsRef;
    private readonly googleMapsMenuOptions;
    private placeGeoCodeTask;
    /**
     * @stable [09.01.2020]
     * @param {IPlaceFieldProps} props
     */
    constructor(props: IPlaceFieldProps);
    /**
     * @stable [09.01.2020]
     */
    componentWillUnmount(): void;
    /**
     * @stable [11.08.2020]
     * @param option
     * @protected
     */
    protected onSelect(option: IPlaceSelectOptionEntity): void;
    /**
     * @stable [11.01.2020]
     * @param {PlaceEntityValueT} value
     * @returns {string}
     */
    protected decorateDisplayValue(value: PlaceEntityValueT): string;
    /**
     * @stable [09.01.2020]
     * @returns {JSX.Element}
     */
    protected get attachmentElement(): JSX.Element;
    /**
     * @stable [09.01.2020]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [11.01.2020]
     * @param {IPlaceGeoCodeRequestEntity} geoCodeRequest
     * @param {IPlaceSelectOptionEntity} option
     */
    private refreshGeocodeInfo;
    /**
     * @stable [11.01.2020]
     * @param {IPlaceEntity[]} result
     * @param {IPlaceSelectOptionEntity} option
     */
    private onGeoCodeRequestDone;
    /**
     * @stable [29.01.2020]
     * @param {IPlaceEntity} placeEntity
     * @param {IPlaceSelectOptionEntity} option
     */
    private doSelect;
    /**
     * @stable [09.01.2020]
     * @param {IGoogleMapsMenuItemEntity} payload
     */
    private onDialogMenuActionSelect;
    /**
     * @stable [11.01.2020]
     */
    private onDialogAccept;
    /**
     * @stable [09.01.2020]
     */
    private onDialogDeactivate;
    /**
     * @stable [09.01.2020]
     */
    private openDialog;
    /**
     * @stable [09.01.2020]
     */
    private cancelPlaceGeoCodeTask;
    /**
     * @stable [03.04.2020]
     */
    private initPlaceMarker;
    /**
     * @stable [17.05.2020]
     * @param {PlaceEntityValueT} placeEntity
     * @returns {string}
     */
    private fromPlaceEntityToDisplayValue;
    /**
     * @stable [28.01.2020]
     * @param {PlaceEntityValueT} placeEntity
     * @returns {string}
     */
    private zipCodeEntityAsDisplayValue;
    /**
     * @stable [09.01.2020]
     * @returns {boolean}
     */
    private get isPlaceChanged();
    /**
     * @stable [03.04.2020]
     * @returns {IPlaceEntity}
     */
    private get valueAsPlaceEntity();
    /**
     * @stable [09.01.2020]
     * @returns {IDialog}
     */
    private get dialog();
    /**
     * @stable [09.01.2020]
     * @returns {IGoogleMaps}
     */
    private get googleMaps();
    /**
     * @stable [11.01.2020]
     * @returns {boolean}
     */
    private get useZipCode();
    /**
     * @stable [03.04.2020]
     * @returns {boolean}
     */
    private get hasMapInitialMarkers();
}
