/// <reference types="react" />
import { Field2 } from '../field';
import { IBaseTextFieldProps, IBaseTextFieldState, IFieldActionEntity } from '../../../definition';
export declare class BaseTextField<TProps extends IBaseTextFieldProps = IBaseTextFieldProps, TState extends IBaseTextFieldState = IBaseTextFieldState> extends Field2<TProps, TState> {
    static readonly defaultProps: IBaseTextFieldProps & Partial<import("../../../definition").IGenericComponentProps<any>>;
    private static readonly DEFAULT_MASK_GUIDE;
    protected defaultActions: IFieldActionEntity[];
    /**
     * @stable [17.06.2020]
     * @param {TProps} originalProps
     */
    constructor(originalProps: TProps);
    /**
     * @stable [25.02.2019]
     * @returns {JSX.Element}
     */
    protected getInputElement(): JSX.Element;
    /**
     * @stable [18.06.2020]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [12.09.2018]
     * @returns {JSX.Element}
     */
    protected get mirrorInputElement(): JSX.Element;
    /**
     * @stable [28.10.2019]
     * @param {} action
     * @returns {boolean}
     */
    protected isFieldActionDisabled(action: IFieldActionEntity): boolean;
    /**
     * @stable [25.02.2019]
     * @returns {JSX.Element}
     */
    private getMaskedInputElement;
    /**
     * @stable [18.04.2020]
     * @returns {JSX.Element}
     */
    protected get actionsElement(): JSX.Element;
    /**
     * @stable [30.10.2019]
     */
    private addClearAction;
    /**
     * @stable [17.06.2020]
     * @returns {IFieldActionEntity[]}
     */
    private get fieldActions();
    /**
     * @stable [21.06.2020]
     * @returns {boolean}
     */
    private get isActioned();
}
