/// <reference types="react" />
import { Field2 } from '../field/field2.component';
import { IViewFieldProps, IViewFieldState } from '../../../definition';
export declare class ViewField extends Field2<IViewFieldProps, IViewFieldState> {
    static readonly defaultProps: IViewFieldProps;
    private previousValue;
    private detectorFileTypeTask;
    /**
     * @stable [29.07.2019]
     * @param {IViewFieldProps} props
     */
    constructor(props: IViewFieldProps);
    /**
     * @stable [29.07.2019]
     */
    componentWillUnmount(): void;
    /**
     * @stable [19.06.2020]
     * @returns {Promise<void>}
     */
    componentDidMount(): Promise<void>;
    /**
     * @stable [19.06.2020]
     * @param {IViewFieldProps} prevProps
     * @param {IViewFieldState} prevState
     * @returns {Promise<void>}
     */
    componentDidUpdate(prevProps: IViewFieldProps, prevState: IViewFieldState): Promise<void>;
    /**
     * @stable [19.06.2020]
     * @returns {JSX.Element}
     */
    protected get attachmentElement(): JSX.Element;
    /**
     * @stable [19.06.2020]
     * @returns {JSX.Element}
     */
    private get viewElement();
    /**
     * @stable [19.06.2020]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * stable [19.09.2019]
     */
    private doRefresh;
    /**
     * @stable [29.07.2019]
     * @returns {string}
     */
    private get currentValue();
    /**
     * @stable [19.09.2019]
     */
    private doClear;
    /**
     * @stable [19.09.2019]
     * @param {string} currentValue
     * @returns {Promise<IViewFieldState>}
     */
    private getFileInfo;
}
