/// <reference types="react" />
import { IApiEntity, IFormProps } from '../../definition';
import { GenericComponent } from '../base';
export declare class Form extends GenericComponent<IFormProps, {}, HTMLFormElement> {
    static readonly defaultProps: IFormProps;
    private static readonly logger;
    private readonly fieldsPresets;
    /**
     * @stable [02.09.2020]
     * @param originalProps
     */
    constructor(originalProps: IFormProps);
    /**
     * @stable [02.09.2020]
     */
    render(): JSX.Element;
    /**
     * @stable [30.06.2020]
     */
    componentDidMount(): void;
    /**
     * @stable [02.09.2020]
     * @param prevProps
     */
    componentDidUpdate(prevProps: IFormProps): void;
    /**
     * @stable [30.06.2020]
     */
    submit(): void;
    /**
     * @stable [11.09.2020]
     * @param event
     * @private
     */
    private onKeyDown;
    /**
     * @stable [07.08.2020]
     * @param name
     * @param value
     * @private
     */
    private onChange;
    /**
     * @stable [07.08.2020]
     */
    private doValid;
    /**
     * @stable [01.09.2020]
     */
    private doSubmit;
    /**
     * @stable [01.09.2020]
     * @private
     */
    private doReset;
    /**
     * @stable [11.05.2020]
     * @returns {boolean}
     */
    private get isFormValid();
    /**
     * @stable [23.03.2020]
     * @returns {boolean}
     */
    private get isFormSubmittable();
    /**
     * @stable [23.03.2020]
     * @returns {boolean}
     */
    private get isFormResettable();
    /**
     * @stable [31.07.2020]
     */
    private get isFormOfNewEntity();
    /**
     * @stable [11.05.2020]
     * @returns {boolean}
     */
    private get isFormBusy();
    /**
     * @stable [23.03.2020]
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldDisabled;
    /**
     * @stable [16.11.2019]
     * @param {IField} field
     * @returns {AnyT}
     */
    private getFieldValue;
    /**
     * @stable [10.09.2020]
     * @param field
     * @private
     */
    private getFieldOriginalValue;
    /**
     * @stable [11.05.2020]
     * @param {IField} field
     * @param {IFieldProps} defaultProps
     * @returns {AnyT}
     */
    private getFieldDisplayValue;
    /**
     * @stable [03.02.2020]
     * @param {IField} field
     * @returns {IFieldProps}
     */
    private getPredefinedFieldProps;
    /**
     * @stable [02.09.2020]
     * @private
     */
    private get formActionsElements();
    /**
     * @stable [03.02.2020]
     * @returns {React.ReactNode[]}
     */
    private get formNodes();
    /**
     * @stable [02.09.2020]
     * @private
     */
    private get actions();
    /**
     * @stable [12.06.2020]
     * @returns {string}
     */
    private get className();
    /**
     * @stable [31.07.2020]
     */
    get apiEntity(): IApiEntity;
    /**
     * @stable [31.07.2020]
     */
    private get hasError();
    /**
     * @stable [21.08.2020]
     * @param field
     */
    private isFieldReadOnly;
    /**
     * @stable [21.08.2020]
     * @param field
     */
    private isFieldChangeable;
    /**
     * @stable [21.08.2020]
     */
    private get form();
}
