/// <reference types="react" />
import { GenericComponent } from '../../base/generic.component';
import { IDefaultLayoutProps } from '../../../definition';
export declare class DefaultLayout extends GenericComponent<IDefaultLayoutProps> {
    static readonly defaultProps: IDefaultLayoutProps;
    /**
     * @stable [21.05.2020]
     * @param {IDefaultLayoutProps} props
     */
    constructor(props: IDefaultLayoutProps);
    /**
     * @stable [12.06.2020]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [21.05.2020]
     * @returns {JSX.Element}
     */
    private get bodyElement();
    /**
     * @stable [12.08.2020]
     * @private
     */
    private get headerElement();
    /**
     * @stable [21.05.2020]
     * @returns {JSX.Element}
     */
    private get subHeaderElement();
    /**
     * @stable [04.02.2020]
     * @returns {JSX.Element}
     */
    private get drawerElement();
    /**
     * @stable [27.05.2020]
     * @returns {JSX.Element}
     */
    private get drawerHeaderElement();
    /**
     * @stable [27.05.2020]
     */
    private onDrawerHeaderMenuActionClick;
    /**
     * @stable [21.05.2020]
     * @returns {boolean}
     */
    private get isNavigationActionRendered();
    /**
     * @stable [21.05.2020]
     * @returns {boolean}
     */
    private get isLayoutFullModeEnabled();
    /**
     * @stable [21.05.2020]
     * @returns {boolean}
     */
    private get isLayoutInProgress();
    /**
     * @stable [21.05.2020]
     * @returns {LayoutModesEnum}
     */
    private get layoutMode();
    /**
     * @stable [02.06.2020]
     * @returns {IDefaultLayoutProps}
     */
    protected get componentsSettingsProps(): IDefaultLayoutProps;
}
