/// <reference types="react" />
import { INavigationListProps, INavigationListState } from '../../definition';
import { EnhancedGenericComponent } from '../base/enhanced-generic.component';
export declare class NavigationList extends EnhancedGenericComponent<INavigationListProps, INavigationListState> {
    private readonly menuRef;
    private readonly itemsRefsMap;
    /**
     * @stable [14.05.2020]
     * @param {INavigationListProps} props
     */
    constructor(props: INavigationListProps);
    /**
     * @stable [14.05.2020]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [23.03.2020]
     */
    componentWillUnmount(): void;
    private toElement;
    /**
     * @stable [14.05.2020]
     * @param {IPresetsMenuItemEntity<INavigationListItemEntity>} option
     */
    private onPopupMenuItemSelect;
    /**
     * @stable [14.05.2020]
     * @param {INavigationListItemEntity} $entity
     * @param {boolean} $isFullModeEnabled
     * @param {INavigationListProps} $mergedProps
     */
    private onGroupClick;
    /**
     * @stable [23.09.2018]
     * @param {INavigationListItemEntity} item
     * @returns {boolean}
     */
    private isItemExpanded;
    /**
     * @stable [23.09.2018]
     * @param {INavigationListItemEntity} item
     * @returns {boolean}
     */
    private hasActiveChild;
    /**
     * @stable [24.03.2020]
     * @param {INavigationListItemEntity} item
     * @param {INavigationListItemEntity} activeGroup
     * @returns {INavigationListItemEntity}
     */
    private asPopupMenuItem;
    private asPopupMenuElement;
    /**
     * @stable [14.05.2020]
     * @param {INavigationListItemEntity} item
     * @param {boolean} $isGroup
     * @param {boolean} $isFullModeEnabled
     * @param {boolean} $isExpanded
     * @returns {JSX.Element}
     */
    private asItemElement;
    /**
     * @stable [14.05.2020]
     * @param {INavigationListItemEntity} item
     * @param {string} extraClassName
     * @returns {JSX.Element}
     */
    private asItemIconElement;
    /**
     * @stable [14.05.2020]
     * @param {boolean} $isExpanded
     * @returns {JSX.Element}
     */
    private asItemExpandIconElement;
    /**
     * @stable [14.05.2020]
     * @returns {HTMLElement}
     */
    private asPopupMenuAnchorElement;
    /**
     * @stable [14.05.2020]
     * @param {boolean} $isGroup
     * @param {boolean} $isActive
     * @param {boolean} $isExpanded
     * @returns {string}
     */
    private asItemClassName;
    /**
     * @stable [14.05.2020]
     * @param {INavigationListProps} $mergedProps
     * @returns {string}
     */
    private asClassName;
    /**
     * @stable [14.05.2020]
     * @param {INavigationListProps} $mergedProps
     * @returns {boolean}
     */
    private isFullLayoutModeEnabled;
    /**
     * @stable [02.06.2020]
     * @returns {INavigationListProps}
     */
    protected get componentsSettingsProps(): INavigationListProps;
    /**
     * @stable [14.05.2020]
     * @param {string} link
     * @param {string} prefix
     * @returns {string}
     */
    private asUniqueKey;
}
