"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.notificationReducer = void 0;
var definition_1 = require("../../definition");
var util_1 = require("../../util");
/**
 * @stable [13.02.2020]
 * @param {IReduxNotificationEntity} state
 * @param {IEffectsAction} action
 * @returns {IReduxNotificationEntity}
 */
exports.notificationReducer = function (state, action) {
    if (state === void 0) { state = definition_1.INITIAL_REDUX_NOTIFICATION_ENTITY; }
    var notificationEntity = util_1.selectData(action);
    switch (action.type) {
        case definition_1.$_RAC_NOTIFICATION_INFO_ACTION_TYPE:
            return __assign(__assign({}, state), { info: notificationEntity.info });
        case definition_1.$_RAC_NOTIFICATION_ERROR_ACTION_TYPE:
            return __assign(__assign({}, state), { error: util_1.asErrorMessage(notificationEntity.error).message });
        case definition_1.$_RAC_NOTIFICATION_CLEAR_ACTION_TYPE:
            return __assign({}, definition_1.INITIAL_REDUX_NOTIFICATION_ENTITY);
    }
    return state;
};
//# sourceMappingURL=notification.reducer.js.map