"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OAuthOpenIdCallbackEffects = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var ts_smart_logger_1 = require("ts-smart-logger");
var appauth_1 = require("@openid/appauth");
var di_1 = require("../../../di");
var definition_1 = require("../../../definition");
var action_1 = require("../../../action");
var jwt_1 = require("../../../util/jwt");
var definitions_interface_1 = require("../../../definitions.interface");
var application_action_builder_1 = require("../../application/application-action.builder"); // TODO Move
var util_1 = require("../../../util");
var OAuthOpenIdCallbackEffects = /** @class */ (function () {
    function OAuthOpenIdCallbackEffects() {
        /**
         * See inside the "@openid/appauth" package
         *
         * @stable [13.03.2020]
         * @param {string} handle
         * @returns {string}
         */
        this.authorizationRequestKey = function (handle) { return handle + "_appauth_authorization_request"; };
        /**
         * See inside the "@openid/appauth" package
         *
         * @stable [13.03.2020]
         * @param {string} handle
         * @returns {string}
         */
        this.authorizationServiceConfigurationKey = function (handle) { return handle + "_appauth_authorization_service_configuration"; };
    }
    OAuthOpenIdCallbackEffects_1 = OAuthOpenIdCallbackEffects;
    /**
     * @stable [13.03.2020]
     * @returns {Promise<IEffectsAction[]>}
     */
    OAuthOpenIdCallbackEffects.prototype.$onConnectorInit = function () {
        return __awaiter(this, void 0, void 0, function () {
            var params, code, key, authRequest, request, configuration, tokenHandler, response, token;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.auth.isAuthorized()) {
                            OAuthOpenIdCallbackEffects_1.logger.debug(function () {
                                return "[$OAuthOpenIdCallbackEffects][$onConnectorInit] The application is already authorized, exit...";
                            });
                            return [2 /*return*/, null];
                        }
                        params = this.environment.getUrlQueryParams();
                        code = params.code;
                        return [4 /*yield*/, this.getValueFromStorage(OAuthOpenIdCallbackEffects_1.AUTHORIZATION_REQUEST_HANDLE_KEY)];
                    case 1:
                        key = _a.sent();
                        return [4 /*yield*/, this.getValueFromStorage(this.authorizationRequestKey(key))];
                    case 2:
                        authRequest = _a.sent();
                        request = new appauth_1.TokenRequest({
                            client_id: this.settings.oauth.clientId,
                            redirect_uri: this.environment.getSectionFullPath(this.settings.routes.oauthCallback),
                            grant_type: appauth_1.GRANT_TYPE_AUTHORIZATION_CODE,
                            code: code,
                            refresh_token: definitions_interface_1.UNDEF,
                            extras: util_1.notNilValuesFilter({ code_verifier: authRequest.internal.code_verifier }),
                        });
                        return [4 /*yield*/, this.getValueFromStorage(this.authorizationServiceConfigurationKey(key))];
                    case 3:
                        configuration = _a.sent();
                        tokenHandler = new appauth_1.BaseTokenRequestHandler();
                        return [4 /*yield*/, tokenHandler.performTokenRequest(new appauth_1.AuthorizationServiceConfiguration(configuration), request)];
                    case 4:
                        response = _a.sent();
                        OAuthOpenIdCallbackEffects_1.logger.debug(function () {
                            return "[$OAuthOpenIdCallbackEffects][$onConnectorInit] The token has been generated successfully. The token payload:";
                        }, response);
                        token = response.accessToken;
                        return [2 /*return*/, [
                                action_1.userActionBuilder.buildReplaceAction(this.fieldConverter.fromOAuthJwtDecodedInfoToUserEntity(jwt_1.decodeJwt(token))),
                                application_action_builder_1.ApplicationActionBuilder.buildAfterLoginAction({ token: token })
                            ]];
                }
            });
        });
    };
    /**
     * @stable [13.03.2020]
     * @param {string} key
     * @returns {Promise<TResult>}
     */
    OAuthOpenIdCallbackEffects.prototype.getValueFromStorage = function (key) {
        return this.notVersionedSessionStorage.get(key, true);
    };
    var OAuthOpenIdCallbackEffects_1;
    OAuthOpenIdCallbackEffects.logger = ts_smart_logger_1.LoggerFactory.makeLogger('OAuthOpenIdCallbackEffects');
    // See inside the "@openid/appauth" package
    OAuthOpenIdCallbackEffects.AUTHORIZATION_REQUEST_HANDLE_KEY = 'appauth_current_authorization_request';
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Auth),
        __metadata("design:type", Object)
    ], OAuthOpenIdCallbackEffects.prototype, "auth", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Environment),
        __metadata("design:type", Object)
    ], OAuthOpenIdCallbackEffects.prototype, "environment", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.FieldConverter),
        __metadata("design:type", Object)
    ], OAuthOpenIdCallbackEffects.prototype, "fieldConverter", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.NotVersionedSessionStorage),
        __metadata("design:type", Object)
    ], OAuthOpenIdCallbackEffects.prototype, "notVersionedSessionStorage", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Settings),
        __metadata("design:type", Object)
    ], OAuthOpenIdCallbackEffects.prototype, "settings", void 0);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(action_1.ConnectorActionBuilder.buildInitActionType(definition_1.OAUTH_CALLBACK_SECTION)),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], OAuthOpenIdCallbackEffects.prototype, "$onConnectorInit", null);
    OAuthOpenIdCallbackEffects = OAuthOpenIdCallbackEffects_1 = __decorate([
        di_1.provideInSingleton(OAuthOpenIdCallbackEffects_1)
    ], OAuthOpenIdCallbackEffects);
    return OAuthOpenIdCallbackEffects;
}());
exports.OAuthOpenIdCallbackEffects = OAuthOpenIdCallbackEffects;
//# sourceMappingURL=oauth-openid-callback.effects.js.map