"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormStoreProxy = void 0;
var action_1 = require("../../../../action");
var store_proxy_1 = require("../store.proxy");
var FormStoreProxy = /** @class */ (function (_super) {
    __extends(FormStoreProxy, _super);
    /**
     * @stable [30.03.2020]
     * @param {IGenericContainer<TProps extends IGenericContainerProps>} container
     */
    function FormStoreProxy(container) {
        var _this = _super.call(this, container) || this;
        _this.container = container;
        _this.dispatchFormChanges = _this.dispatchFormChanges.bind(_this);
        _this.dispatchFormClear = _this.dispatchFormClear.bind(_this);
        _this.dispatchFormReset = _this.dispatchFormReset.bind(_this);
        _this.dispatchFormSubmit = _this.dispatchFormSubmit.bind(_this);
        _this.dispatchFormValid = _this.dispatchFormValid.bind(_this);
        return _this;
    }
    /**
     * @stable [12.04.2020]
     * @param {number} value
     * @param {string} otherSection
     */
    FormStoreProxy.prototype.dispatchFormActiveValue = function (value, otherSection) {
        this.dispatchPlainAction(action_1.FormActionBuilder.buildActiveValuePlainAction(this.asSection(otherSection), value));
    };
    /**
     * @stable [12.04.2020]
     * @param {number} value
     * @param {string} otherSection
     */
    FormStoreProxy.prototype.dispatchFormInactiveValue = function (value, otherSection) {
        this.dispatchPlainAction(action_1.FormActionBuilder.buildInactiveValuePlainAction(this.asSection(otherSection), value));
    };
    /**
     * @stable [09.10.2019]
     * @param {string} otherSection
     */
    FormStoreProxy.prototype.dispatchFormReset = function (otherSection) {
        this.dispatchPlainAction(action_1.FormActionBuilder.buildResetPlainAction(this.asSection(otherSection)));
    };
    /**
     * @stable [23.04.2020]
     * @param {string} fieldName
     * @param {string} otherSection
     */
    FormStoreProxy.prototype.dispatchFormClear = function (fieldName, otherSection) {
        this.dispatchPlainAction(action_1.FormActionBuilder.buildClearPlainAction(this.asSection(otherSection), fieldName));
    };
    /**
     * @stable [01.03.2020]
     * @param {IApiEntity} apiEntity
     * @param {string} otherSection
     */
    FormStoreProxy.prototype.dispatchFormSubmit = function (apiEntity, otherSection) {
        this.dispatchPlainAction(action_1.FormActionBuilder.buildSubmitPlainAction(this.asSection(otherSection), apiEntity));
    };
    /**
     * @stable [03.02.2020]
     * @param {boolean} valid
     * @param {string} otherSection
     */
    FormStoreProxy.prototype.dispatchFormValid = function (valid, otherSection) {
        this.dispatchPlainAction(action_1.FormActionBuilder.buildValidPlainAction(this.asSection(otherSection), valid));
    };
    /**
     * @stable [09.10.2019]
     * @param {TChanges} changes
     * @param {string} otherSection
     */
    FormStoreProxy.prototype.dispatchFormChanges = function (changes, otherSection) {
        this.dispatchPlainAction(action_1.FormActionBuilder.buildChangesPlainAction(this.asSection(otherSection), changes));
    };
    /**
     * @stable [01.04.2020]
     * @param {TChanges} changes
     * @param {string} otherSection
     */
    FormStoreProxy.prototype.dispatchFormDefaultChanges = function (changes, otherSection) {
        this.dispatchPlainAction(action_1.FormActionBuilder.buildDefaultChangesPlainAction(this.asSection(otherSection), changes));
    };
    return FormStoreProxy;
}(store_proxy_1.StoreProxy));
exports.FormStoreProxy = FormStoreProxy;
//# sourceMappingURL=form-store.proxy.js.map