"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tabPanelReducer = void 0;
var definition_1 = require("../../definition");
var action_1 = require("../../action");
var util_1 = require("../../util");
/**
 * @stable [12.04.2020]
 * @param {IGenericTabPanelEntity} state
 * @param {IEffectsAction} action
 * @returns {IGenericTabPanelEntity}
 */
exports.tabPanelReducer = function (state, action) {
    if (state === void 0) { state = definition_1.INITIAL_REDUX_TAB_PANEL_ENTITY; }
    var section = util_1.Selectors.sectionFromAction(action);
    var activeValueFluxEntity = action.data;
    switch (action.type) {
        case action_1.TabPanelActionBuilder.buildDestroyActionType(section):
            return {};
        case action_1.TabPanelActionBuilder.buildActiveValueActionType(section):
            return __assign(__assign({}, state), { activeValue: activeValueFluxEntity.payload });
    }
    return state;
};
//# sourceMappingURL=tab-panel.reducer.js.map