import { IPresetsXYEntity } from './xy-definition.interface';
import { IExpandedGroupsWrapper, ILayoutWrapper, IModeWrapper, ITopTitleWrapper } from '../definitions.interface';
import { IGenericComponentProps } from './generic-component-definition.interface';
/**
 * @enum
 * @stable [08.05.2020]
 */
export declare enum LayoutModesEnum {
    FULL = 0,
    MINIMAL = 1
}
/**
 * @redux-entity
 * @stable [08.05.2020]
 */
export interface IReduxLayoutEntity extends IExpandedGroupsWrapper<{}>, IModeWrapper<LayoutModesEnum>, IPresetsXYEntity {
}
/**
 * @redux-holder-entity
 * @stable [21.05.2020]
 */
export interface IReduxLayoutHolderEntity<TEntity = IReduxLayoutEntity> extends ILayoutWrapper<TEntity> {
}
/**
 * @presets-entity
 * @stable [27.05.2020]
 */
export interface IPresetsFormLayoutEntity extends ITopTitleWrapper {
}
/**
 * @generic-entity
 * @stable [27.05.2020]
 */
export interface IGenericFormLayoutEntity extends IPresetsFormLayoutEntity {
}
/**
 * @props
 * @stable [13.02.2020]
 */
export interface IFormLayoutProps extends IGenericComponentProps, IGenericFormLayoutEntity {
}
/**
 * @enum
 * @stable [28.09.2019]
 */
export declare enum LayoutGroupsValuesEnum {
    HOME = "home"
}
/**
 * @initial-redux-entity
 * @stable [08.05.2020]
 */
export declare const INITIAL_REDUX_LAYOUT_ENTITY: Readonly<IReduxLayoutEntity>;
/**
 * @classes
 * @stable [08.05.2020]
 */
export declare enum LayoutClassesEnum {
    FORM_LAYOUT = "rac-form-layout",
    FORM_LAYOUT_CONTENT = "rac-form-layout__content",
    FORM_LAYOUT_TOP_HEADER = "rac-form-layout__top-header"
}
