import { IBaseSelectProps } from './select-definition.interface';
import { IBasicListProps, IListItemProps } from './list-definition.interface';
import { IButtonProps } from './button-definition.interface';
import { IChartProps } from './chart-definition.interface';
import { IDefaultLayoutProps } from './default-layout-definition.interface';
import { IDialogProps } from './dialog-definition.interface';
import { IDrawerProps } from './drawer-definition.interface';
import { IFieldProps } from './field-definition.interface';
import { IFormLayoutProps } from './layout-definition.interface';
import { IGridHeadProps, IGridRowProps } from './grid-definition.interface';
import { IHeaderProps } from './header-definition.interface';
import { IInlineOptionProps } from './inline-option-definition.interface';
import { IMainProps } from './main-definition.interface';
import { INavigationListProps } from './navigation-list-definition.interface';
import { IPageToolbarProps } from './toolbar-definition.interface';
import { ISubHeaderLinkProps } from './sub-header-link-definition.interface';
import { ISubHeaderProps } from './sub-header-definition.interface';
import { IThumbProps } from './thumb-definition.interface';
import { ITitleProps } from './title-definition.interface';
/**
 * @stable [03.05.2020]
 */
export declare enum StartDaysOfWeekEnum {
    MONDAY = 0,
    SUNDAY = 1
}
/**
 * @entity
 * @stable [09.09.2020]
 */
export interface ICurrencySettingsEntity {
    currency?: string;
    fractionalFormatOptions?: Intl.NumberFormatOptions;
    integerFormatOptions?: Intl.NumberFormatOptions;
    locale?: string;
    shortCurrency?: string;
}
/**
 * @default-entity
 * @stable [09.09.2020]
 */
export declare const DEFAULT_CURRENCY_SETTINGS_ENTITY: Readonly<ICurrencySettingsEntity>;
/**
 * @stable [25.12.2019]
 */
export interface IDateTimeSettingsEntity {
    currentDate?: Date;
    dateTimeFormat?: string;
    maxDate?: Date;
    minDate?: Date;
    startDayOfWeek?: StartDaysOfWeekEnum;
    uiDateFormat?: string;
    uiDateMask?: (string | RegExp)[];
    uiDatePattern?: string;
    uiDefaultTime?: string;
    uiTimeFormat?: string;
    uiYearMonthFormat?: string;
    uiYearPattern?: string;
}
/**
 * @stable [25.12.2019]
 */
export declare const DEFAULT_DATE_TIME_SETTINGS_ENTITY: Readonly<IDateTimeSettingsEntity>;
/**
 * @settings-entity
 * @stable [20.05.2020]
 */
export interface IElementsMarkersSettingsEntity {
    selectedElement?: string;
    stickyElement?: string;
}
/**
 * @default-entity
 * @stable [20.05.2020]
 */
export declare const DEFAULT_ELEMENTS_MARKERS_SETTINGS_ENTITY: Readonly<IElementsMarkersSettingsEntity>;
/**
 * @entity
 * @stable [04.02.2020]
 */
export interface IComponentsSettingsEntity {
    baseSelect?: IBaseSelectProps;
    basicList?: IBasicListProps;
    button?: IButtonProps;
    chart?: IChartProps;
    defaultLayout?: IDefaultLayoutProps;
    dialog?: IDialogProps;
    drawer?: IDrawerProps;
    field?: IFieldProps;
    formLayout?: IFormLayoutProps;
    gridHead?: IGridHeadProps;
    gridRow?: IGridRowProps;
    header?: IHeaderProps;
    inlineOption?: IInlineOptionProps;
    listItem?: IListItemProps;
    main?: IMainProps;
    navigationList?: INavigationListProps;
    pageToolbar?: IPageToolbarProps;
    subHeader?: ISubHeaderProps;
    subHeaderLink?: ISubHeaderLinkProps;
    thumb?: IThumbProps;
    title?: ITitleProps;
}
/**
 * @default-entity
 * @stable [24.03.2020]
 */
export declare const DEFAULT_COMPONENTS_SETTINGS_ENTITY: Readonly<IComponentsSettingsEntity>;
/**
 * @entity
 * @stable [09.01.2020]
 */
export interface IRoutesSettingsEntity {
    accessDenied?: string;
    home?: string;
    logout?: string;
    oauthCallback?: string;
    oauthSignIn?: string;
    profile?: string;
    signIn?: string;
}
/**
 * @default-entity
 * @stable [09.01.2020]
 */
export declare const DEFAULT_ROUTES_SETTINGS_ENTITY: Readonly<IRoutesSettingsEntity>;
/**
 * @entity
 * @stable [13.03.2020]
 */
export interface IOAuthSettingsEntity {
    clientId?: string;
    scope?: string;
}
/**
 * @default-entity
 * @stable [13.03.2020]
 */
export declare const DEFAULT_OAUTH_SETTINGS_ENTITY: Readonly<IOAuthSettingsEntity>;
/**
 * @entity
 * @stable [09.01.2020]
 */
export interface IAsyncLibrariesSettingsEntity {
    googleMaps?: string;
}
/**
 * @default-entity
 * @stable [09.01.2020]
 */
export declare const DEFAULT_ASYNC_LIBRARIES_SETTINGS_ENTITY: Readonly<IAsyncLibrariesSettingsEntity>;
/**
 * @stable [10.01.2020]
 */
export interface IGoogleMapsSettingsEntity {
    componentRestrictions?: {
        country?: string;
    };
    lat?: number;
    libraries?: string;
    lng?: number;
    prettyZoom?: number;
    zoom?: number;
}
/**
 * @default-entity
 * @stable [10.01.2020]
 */
export declare const DEFAULT_GOOGLE_MAPS_SETTINGS_ENTITY: Readonly<IGoogleMapsSettingsEntity>;
/**
 * @stable [29.11.0219]
 */
export interface IPhoneSettingsEntity {
    countryAbbr?: string;
    uiMask?: (string | RegExp)[];
}
/**
 * @stable [29.11.0219]
 */
export declare const DEFAULT_PHONE_SETTINGS_ENTITY: Readonly<IPhoneSettingsEntity>;
/**
 * @entity
 * @stable [06.02.2020]
 */
export interface IUrlsSettingsEntity {
    emptyAvatar?: string;
    pdfWorker?: string;
}
/**
 * @default-entity
 * @stable [06.02.2020]
 */
export declare const DEFAULT_URLS_SETTINGS_ENTITY: Readonly<IUrlsSettingsEntity>;
/**
 * @stable [07.10.2019]
 */
export interface IMessagesSettingsEntity {
    ADDRESS_SELECTION?: string;
    AN_ERROR_OCCURRED_DURING_LOADING_THE_FILE?: string;
    APPLICATION_IS_INITIALIZING?: string;
    APPLY?: string;
    BUILD?: string;
    CHANGES_YOU_MADE_WILL_NOT_BE_SAVED?: string;
    CLEAR_ALL?: string;
    CLOSE?: string;
    COMPARE_TO?: string;
    CREATE?: string;
    CUSTOM?: string;
    DATA_HAS_BEEN_SUCCESSFULLY_SAVED?: string;
    DATE?: string;
    DAY?: string;
    DETAILS_INFO?: string;
    DIALOG_ACCEPT?: string;
    DIALOG_CANCEL?: string;
    DIALOG_DISCARD?: string;
    ENVIRONMENT?: string;
    ERROR?: string;
    EXPORT?: string;
    FILTERS?: string;
    FIRST?: string;
    LAST?: string;
    LAST_MONTH?: string;
    LAST_QUARTER?: string;
    LAST_WEEK?: string;
    LAST_YEAR?: string;
    LOG_OUT?: string;
    MAX_LENGTH_OF?: string;
    NA?: string;
    NEW_APP_VERSION_HAS_BEEN_DEPLOYED?: string;
    NEXT?: string;
    NO_AVAILABLE_ITEMS_TO_SELECT?: string;
    NO_DATA?: string;
    NOT_DATA_FOUND?: string;
    OK?: string;
    PAGES_INFO?: string;
    PATH?: string;
    PLEASE_WAIT?: string;
    PLS_SEND_THIS_SCR_TO_SUPPORT_MANAGER?: string;
    PREVIEW?: string;
    PREVIOUS?: string;
    PUT_MARKER_HERE?: string;
    REFRESH?: string;
    RESET?: string;
    RESTART_APP?: string;
    SAVE?: string;
    SEARCH?: string;
    SETTINGS?: string;
    SHORT_PAGES_INFO?: string;
    SOMETHING_WENT_WRONG?: string;
    THIS_MONTH?: string;
    THIS_QUARTER?: string;
    THIS_WEEK?: string;
    TODAY?: string;
    UNKNOWN_ERROR?: string;
    USER?: string;
    WAITING?: string;
    YEAR?: string;
    YESTERDAY?: string;
}
/**
 * @stable [07.10.2019]
 */
export declare const DEFAULT_MESSAGES_SETTINGS_ENTITY: Readonly<IMessagesSettingsEntity>;
/**
 * @entity
 * @stable [09.09.2020]
 */
export interface INumberConverterSettingsEntity {
    na?: string;
}
/**
 * @default-entity
 * @stable [06.02.2020]
 */
export declare const DEFAULT_NUMBER_CONVERTER_SETTINGS_ENTITY: Readonly<INumberConverterSettingsEntity>;
