"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EffectsFactories = void 0;
var edited_list_effects_proxy_1 = require("./edited-list-effects.proxy");
var failed_effects_proxy_1 = require("./failed-effects.proxy");
var destroyed_container_effects_proxy_1 = require("./destroyed-container-effects.proxy");
var filtered_list_effects_proxy_1 = require("./filtered-list-effects.proxy");
var filter_form_dialog_effects_proxy_1 = require("./filter-form-dialog-effects.proxy");
var loaded_list_on_form_valid_effects_proxy_1 = require("./loaded-list-on-form-valid-effects.proxy");
var loaded_list_on_tab_activate_effects_proxy_1 = require("./loaded-list-on-tab-activate-effects.proxy");
var paginated_list_effects_proxy_1 = require("./paginated-list-effects.proxy");
var succeed_edited_list_effects_proxy_1 = require("./succeed-edited-list-effects.proxy");
var toolbar_tools_effects_proxy_1 = require("./toolbar-tools-effects.proxy");
var untouched_list_effects_proxy_1 = require("./untouched-list-effects.proxy");
/**
 * @stable [07.06.2020]
 */
var EffectsFactories = /** @class */ (function () {
    function EffectsFactories() {
    }
    EffectsFactories.connectorInitErrorEffectsProxy = failed_effects_proxy_1.makeConnectorInitErrorEffectsProxy;
    EffectsFactories.destroyedContainerEffectsProxy = destroyed_container_effects_proxy_1.makeDestroyedContainerEffectsProxy;
    EffectsFactories.editedListEffectsProxy = edited_list_effects_proxy_1.makeEditedListEffectsProxy;
    EffectsFactories.errorEffectsProxy = failed_effects_proxy_1.makeErrorEffectsProxy;
    EffectsFactories.filteredListEffectsProxy = filtered_list_effects_proxy_1.makeFilteredListEffectsProxy;
    EffectsFactories.filterFormDialogEffectsProxy = filter_form_dialog_effects_proxy_1.makeFilterFormDialogEffectsProxy;
    EffectsFactories.formSubmitErrorEffectsProxy = failed_effects_proxy_1.makeFormSubmitErrorEffectsProxy;
    EffectsFactories.listLazyLoadErrorEffectsProxy = failed_effects_proxy_1.makeListLazyLoadErrorEffectsProxy;
    EffectsFactories.listLoadErrorEffectsProxy = failed_effects_proxy_1.makeListLoadErrorEffectsProxy;
    EffectsFactories.loadedListOnFormValidEffectsProxy = loaded_list_on_form_valid_effects_proxy_1.makeLoadedListOnFormValidEffectsProxy;
    EffectsFactories.loadedListOnTabActivateEffectsProxy = loaded_list_on_tab_activate_effects_proxy_1.makeLoadedListOnTabActivateEffectsProxy;
    EffectsFactories.paginatedListEffectsProxy = paginated_list_effects_proxy_1.makePaginatedListEffectsProxy;
    EffectsFactories.succeedEditedListEffectsProxy = succeed_edited_list_effects_proxy_1.makeSucceedEditedListEffectsProxy;
    EffectsFactories.toolbarToolsEffectsProxy = toolbar_tools_effects_proxy_1.makeToolbarToolsEffectsProxy;
    EffectsFactories.untouchedListEffectsProxy = untouched_list_effects_proxy_1.makeUntouchedListEffectsProxy;
    return EffectsFactories;
}());
exports.EffectsFactories = EffectsFactories;
//# sourceMappingURL=effects.factory.js.map