"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DestroyedContainerMiddlewareFactories = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var action_builder_1 = require("../../component/action.builder");
var action_1 = require("../../action");
/**
 * @stable [10.09.2020]
 * @middleware
 *
 * @param config
 */
var makeDestroyedContainerMiddleware = function (config) {
    return __spreadArrays((config.tabPanelsSections || [])
        .map(function (tabPanelSection) { return action_1.TabPanelActionBuilder.buildDestroyAction(tabPanelSection); }), (config.formsSections || [])
        .map(function (formSection) { return action_1.FormActionBuilder.buildDestroyAction(formSection); }), (config.filtersSections || [])
        .map(function (filterSection) { return action_1.FilterActionBuilder.buildDestroyAction(filterSection); }), (config.listsSections || [])
        .map(function (listSection) { return action_builder_1.ListActionBuilder.buildDestroyAction(listSection); }), (config.customActions || [])
        .map(function (customAction) { return redux_effects_promise_1.EffectsAction.create(customAction); }));
};
/**
 * @stable [10.09.2020]
 */
var DestroyedContainerMiddlewareFactories = /** @class */ (function () {
    function DestroyedContainerMiddlewareFactories() {
    }
    DestroyedContainerMiddlewareFactories.destroyedContainerMiddleware = makeDestroyedContainerMiddleware;
    return DestroyedContainerMiddlewareFactories;
}());
exports.DestroyedContainerMiddlewareFactories = DestroyedContainerMiddlewareFactories;
//# sourceMappingURL=destroyed-container.middleware.js.map