/**
 * @stable [07.06.2020]
 */
export declare class MiddlewareFactories {
    static readonly chainedMiddleware: <TPayload, TState>(config: import("../..").IChainedMiddlewareConfigEntity<TState, TPayload>) => import("redux-effects-promise").IEffectsAction[];
    static readonly createEntityMiddleware: <TState = {}, TDefaultChanges = {}>(config: import("../..").IEditedListMiddlewareConfigEntity<{}, TState, TDefaultChanges>) => import("redux-effects-promise").IEffectsAction[];
    static readonly defaultFormChangesMiddleware: <TChanges = {}, TState = {}>(cfg: import("../..").IDefaultFormChangesMiddlewareConfigEntity<TChanges, TState>) => import("redux-effects-promise").IEffectsAction;
    static readonly destroyedContainerMiddleware: (config: import("../..").IDestroyedContainerMiddlewareConfigEntity) => import("redux-effects-promise").IEffectsAction[];
    static readonly filteredListApplyMiddleware: <TState = {}>(cfg: import("../..").IFilteredListMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction[];
    static readonly filteredListDeactivateMiddleware: <TState = {}>(cfg: import("../..").IFilteredListMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction[];
    static readonly filterFormDialogAcceptMiddleware: <TState = {}>(cfg: import("../..").IFilterFormDialogMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction;
    static readonly filterFormDialogClearMiddleware: <TState = {}>(cfg: import("../..").IFilterFormDialogMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction[];
    static readonly filterFormDialogResetMiddleware: <TState = {}>(cfg: import("../..").IFilterFormDialogMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction;
    static readonly lazyLoadedEntityMiddleware: <TPayload = {}, TState = {}, TDefaultChanges = {}>(config: import("../..").IEditedListMiddlewareConfigEntity<TPayload, TState, TDefaultChanges>) => import("redux-effects-promise").IEffectsAction[];
    static readonly loadedListMiddleware: <TState = {}>(cfg: import("../..").ILoadedListMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction;
    static readonly loadedListOnNavigateToFirstPageMiddleware: <TState = {}>(cfg: import("../..").ILoadedListOnNavigateToPageMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction[];
    static readonly loadedListOnNavigateToLastPageMiddleware: <TState = {}>(cfg: import("../..").ILoadedListOnNavigateToPageMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction[];
    static readonly loadedListOnNavigateToNextPageMiddleware: <TState = {}>(cfg: import("../..").ILoadedListOnNavigateToPageMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction[];
    static readonly loadedListOnNavigateToPreviousPageMiddleware: <TState = {}>(cfg: import("../..").ILoadedListOnNavigateToPageMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction[];
    static readonly loadedListOnTabActivateMiddleware: <TState = {}>(config: import("../..").ILoadedListOnTabActivateMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction;
    static readonly selectEntityMiddleware: <TPayload = {}, TState = {}, TDefaultChanges = {}>(cfg: import("../..").IEditedListMiddlewareConfigEntity<TPayload, TState, TDefaultChanges>) => import("redux-effects-promise").IEffectsAction[];
    static readonly succeedEditedListMiddleware: <TState = {}>(cfg: import("../..").ISucceedEditedListMiddlewareConfigEntity<TState>) => import("redux-effects-promise").IEffectsAction[];
    static readonly succeedFormMiddleware: (cfg?: import("../..").ISucceedFormMiddlewareConfigEntity<{}>) => import("redux-effects-promise").IEffectsAction[];
    static readonly untouchedListMiddleware: <TState = {}, TDefaultChanges = {}>(cfg: import("../..").IUntouchedListMiddlewareConfigEntity<TState, TDefaultChanges>) => import("redux-effects-promise").IEffectsAction[];
}
