"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MiddlewareFactories = void 0;
var chained_middleware_1 = require("./chained.middleware");
var edited_list_middleware_1 = require("./edited-list.middleware");
var loaded_list_middleware_1 = require("./loaded-list.middleware");
var succeed_form_middleware_1 = require("./succeed-form.middleware");
var default_form_changes_middleware_1 = require("./default-form-changes.middleware");
var destroyed_container_middleware_1 = require("./destroyed-container.middleware");
var filtered_list_middleware_1 = require("./filtered-list.middleware");
var filer_form_dialog_middleware_1 = require("./filer-form-dialog.middleware");
/**
 * @stable [07.06.2020]
 */
var MiddlewareFactories = /** @class */ (function () {
    function MiddlewareFactories() {
    }
    MiddlewareFactories.chainedMiddleware = chained_middleware_1.makeChainedMiddleware;
    MiddlewareFactories.createEntityMiddleware = edited_list_middleware_1.makeCreateEntityMiddleware;
    MiddlewareFactories.defaultFormChangesMiddleware = default_form_changes_middleware_1.DefaultFormChangesMiddlewareFactories.defaultFormChangesMiddleware;
    MiddlewareFactories.destroyedContainerMiddleware = destroyed_container_middleware_1.DestroyedContainerMiddlewareFactories.destroyedContainerMiddleware;
    MiddlewareFactories.filteredListApplyMiddleware = filtered_list_middleware_1.FilteredListMiddlewareFactories.filteredListApplyMiddleware;
    MiddlewareFactories.filteredListDeactivateMiddleware = filtered_list_middleware_1.FilteredListMiddlewareFactories.filteredListDeactivateMiddleware;
    MiddlewareFactories.filterFormDialogAcceptMiddleware = filer_form_dialog_middleware_1.FilterFormDialogMiddlewareFactories.filterFormDialogAcceptMiddleware;
    MiddlewareFactories.filterFormDialogClearMiddleware = filer_form_dialog_middleware_1.FilterFormDialogMiddlewareFactories.filterFormDialogClearMiddleware;
    MiddlewareFactories.filterFormDialogResetMiddleware = filer_form_dialog_middleware_1.FilterFormDialogMiddlewareFactories.filterFormDialogResetMiddleware;
    MiddlewareFactories.lazyLoadedEntityMiddleware = edited_list_middleware_1.makeLazyLoadedEntityMiddleware;
    MiddlewareFactories.loadedListMiddleware = loaded_list_middleware_1.LoadedListMiddlewareFactories.loadedListMiddleware;
    MiddlewareFactories.loadedListOnNavigateToFirstPageMiddleware = loaded_list_middleware_1.makeLoadedListOnNavigateToFirstPageMiddleware;
    MiddlewareFactories.loadedListOnNavigateToLastPageMiddleware = loaded_list_middleware_1.makeLoadedListOnNavigateToLastPageMiddleware;
    MiddlewareFactories.loadedListOnNavigateToNextPageMiddleware = loaded_list_middleware_1.makeLoadedListOnNavigateToNextPageMiddleware;
    MiddlewareFactories.loadedListOnNavigateToPreviousPageMiddleware = loaded_list_middleware_1.makeLoadedListOnNavigateToPreviousPageMiddleware;
    MiddlewareFactories.loadedListOnTabActivateMiddleware = loaded_list_middleware_1.LoadedListMiddlewareFactories.loadedListOnTabActivateMiddleware;
    MiddlewareFactories.selectEntityMiddleware = edited_list_middleware_1.EditedListMiddlewareFactories.selectEntityMiddleware;
    MiddlewareFactories.succeedEditedListMiddleware = succeed_form_middleware_1.SucceedFormMiddlewareFactories.succeedEditedListMiddleware;
    MiddlewareFactories.succeedFormMiddleware = succeed_form_middleware_1.makeSucceedFormMiddleware;
    MiddlewareFactories.untouchedListMiddleware = loaded_list_middleware_1.LoadedListMiddlewareFactories.untouchedListMiddleware;
    return MiddlewareFactories;
}());
exports.MiddlewareFactories = MiddlewareFactories;
//# sourceMappingURL=middleware.factory.js.map