"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransportEffects = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var ts_smart_logger_1 = require("ts-smart-logger");
var di_1 = require("../di");
var transport_reducer_interface_1 = require("./transport-reducer.interface");
var action_1 = require("../action");
var application_action_builder_1 = require("../component/application/application-action.builder");
var TransportEffects = /** @class */ (function () {
    function TransportEffects() {
    }
    TransportEffects_1 = TransportEffects;
    /**
     * @stable [05.02.2019]
     * @param {IEffectsAction} action
     * @returns {IEffectsAction[] | IEffectsAction}
     */
    TransportEffects.prototype.$onTransportRequestError = function (action) {
        var data = action.data;
        if (this.responseAccessor.isAuthError(data)) {
            /**
             * We should destroy the token and go to logout page
             */
            var actions = [
                application_action_builder_1.ApplicationActionBuilder.buildUnauthorizedAction(),
                action_1.RouterActionBuilder.buildNavigateAction(this.routes.logout)
            ];
            TransportEffects_1.logger.debug(function () {
                return "[$TransportEffects][$onTransportRequestError] An auth error has occurred. Need to redirect to logout. Data: " + JSON.stringify(data);
            });
            return actions;
        }
        return this.errorInterceptor.intercept(data);
    };
    var TransportEffects_1;
    TransportEffects.logger = ts_smart_logger_1.LoggerFactory.makeLogger('TransportEffects');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.TransportResponseAccessor),
        __metadata("design:type", Object)
    ], TransportEffects.prototype, "responseAccessor", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.TransportErrorInterceptor),
        __metadata("design:type", Object)
    ], TransportEffects.prototype, "errorInterceptor", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Routes),
        __metadata("design:type", Object)
    ], TransportEffects.prototype, "routes", void 0);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(transport_reducer_interface_1.TRANSPORT_REQUEST_ERROR_ACTION_TYPE),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Object)
    ], TransportEffects.prototype, "$onTransportRequestError", null);
    TransportEffects = TransportEffects_1 = __decorate([
        di_1.provideInSingleton(TransportEffects_1)
    ], TransportEffects);
    return TransportEffects;
}());
exports.TransportEffects = TransportEffects;
//# sourceMappingURL=transport.effects.js.map