"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntityUtils = exports.entityAsFileName = exports.doesExtendedEntityExist = void 0;
var R = require("ramda");
var cond_1 = require("./cond");
/**
 * @stable [31.07.2020]
 * @param entity
 */
var isNewEntity = function (entity) {
    return R.isNil(entity) || R.isNil(entity.id);
};
/**
 * @stable [17.08.2020]
 * @param entity
 */
var isPhantomEntity = function (entity) {
    return !isNewEntity(entity) && entity.id < 0;
};
/**
 * @stable [01.09.2020]
 * @param entity
 */
var isNewExtendedEntity = function (entity) {
    return R.isNil(entity) || entity.newEntity === true;
};
/**
 * @stable [01.09.2020]
 * @param extendedEntity
 */
exports.doesExtendedEntityExist = function (extendedEntity) {
    return !isNewExtendedEntity(extendedEntity);
};
/**
 * @stable [30.08.2019]
 * @param {TEntity} entity
 * @returns {string}
 */
exports.entityAsFileName = function (entity) { return cond_1.ifNotNilThanValue(entity, function () { return "" + entity.id + cond_1.ifNotNilThanValue(entity.name, function (name) { return "-" + name.replace(/ /g, '_'); }, ''); }, ''); };
/**
 * @stable [31.07.2020]
 */
var EntityUtils = /** @class */ (function () {
    function EntityUtils() {
    }
    EntityUtils.doesExtendedEntityExist = exports.doesExtendedEntityExist;
    EntityUtils.isNewEntity = isNewEntity;
    EntityUtils.isPhantomEntity = isPhantomEntity;
    return EntityUtils;
}());
exports.EntityUtils = EntityUtils;
//# sourceMappingURL=entity.js.map