"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.noop = exports.sequence = void 0;
var util_1 = require("../util");
/**
 * @stable [09.10.2019]
 * @param {(...args) => AnyT} sourceFn
 * @param {(...args) => AnyT} nextFn
 * @param {AnyT} nextFnScope
 * @returns {(...args) => AnyT}
 */
exports.sequence = function (sourceFn, nextFn, nextFnScope) {
    return function () {
        if (util_1.isFn(sourceFn)) {
            sourceFn.apply(this, arguments);
        }
        nextFn.apply(nextFnScope || this, arguments);
    };
};
/* tslint:disable */
function noop() {
}
exports.noop = noop;
//# sourceMappingURL=fn.js.map