"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JoinUtils = exports.joinReduce = exports.join = void 0;
var definitions_interface_1 = require("../definitions.interface");
var array_1 = require("./array");
var filter_1 = require("./filter");
var nvl_1 = require("./nvl");
/**
 * @stable [17.05.2020]
 * @param {AnyT[]} parts
 * @param {string} joiner
 * @returns {string}
 */
exports.join = function (parts, joiner) {
    if (joiner === void 0) { joiner = definitions_interface_1.UniCodesEnum.SPACE; }
    return filter_1.FilterUtils.notNilValuesArrayFilter.apply(filter_1.FilterUtils, parts).join(joiner);
};
/**
 *
 * @param {AnyT[]} parts
 * @returns {string}
 */
exports.joinReduce = function (parts) { return array_1.isArrayNotEmpty(parts)
    ? (parts.length > 1
        ? parts[0] + ", ..."
        : nvl_1.nvl(parts[0], ''))
    : ''; };
/**
 * @stable [17.05.2020]
 */
var JoinUtils = /** @class */ (function () {
    function JoinUtils() {
    }
    JoinUtils.join = exports.join; /* @stable [17.05.2020] */
    return JoinUtils;
}());
exports.JoinUtils = JoinUtils;
//# sourceMappingURL=join.js.map