import { IActiveValueWrapper, IChannelWrapper, IDictionariesWrapper, IDisabledWrapper, IFormWrapper, ILayoutWrapper, IListWrapper, INotificationWrapper, IOptionsWrapper, IPrimaryFilterWrapper, IProgressWrapper, IQueryFilterWrapper, IQueryWrapper, ISecondaryFilterWrapper, ISectionNameWrapper, IStackWrapper, ITabPanelWrapper, ITransportWrapper, IUserWrapper, IWaitingForOptionsWrapper } from '../definitions.interface';
/**
 * @stable [27.07.2020]
 */
export declare class MapAsWrapperUtils {
    static readonly activeValue: <TValue>(activeValue: TValue) => IActiveValueWrapper<TValue>;
    static readonly channel: <TValue>(channel: TValue) => IChannelWrapper<TValue>;
    static readonly dictionaries: <TValue>(dictionaries: TValue) => IDictionariesWrapper<TValue>;
    static readonly disabled: (disabled: boolean) => IDisabledWrapper<boolean>;
    static readonly form: <TForm>(form: TForm) => IFormWrapper<TForm>;
    static readonly layout: <TValue>(layout: TValue) => ILayoutWrapper<TValue>;
    static readonly list: <TList>(list: TList) => IListWrapper<TList>;
    static readonly notification: <TValue>(notification: TValue) => INotificationWrapper<TValue>;
    static readonly options: <TValue>(options: TValue) => IOptionsWrapper<TValue>;
    static readonly primaryFilter: <TEntity = string>(primaryFilter: TEntity) => IPrimaryFilterWrapper<TEntity>;
    static readonly progress: <TValue>(progress: TValue) => IProgressWrapper<TValue>;
    static readonly query: (query: string) => IQueryWrapper<string>;
    static readonly queryFilter: <TEntity = string>(queryFilter: TEntity) => IQueryFilterWrapper<TEntity>;
    static readonly secondaryFilter: <TEntity = string>(secondaryFilter: TEntity) => ISecondaryFilterWrapper<TEntity>;
    static readonly sectionName: (sectionName: string) => ISectionNameWrapper;
    static readonly stack: <TValue>(stack: TValue) => IStackWrapper<TValue>;
    static readonly tabPanel: <TTabPanel>(tabPanel: TTabPanel) => ITabPanelWrapper<TTabPanel>;
    static readonly transport: <TValue>(transport: TValue) => ITransportWrapper<TValue>;
    static readonly user: <TUser>(user: TUser) => IUserWrapper<TUser>;
    static readonly waitingForOptions: (waitingForOptions: boolean) => IWaitingForOptionsWrapper;
}
