"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectOptionUtils = void 0;
var R = require("ramda");
var type_1 = require("./type");
var di_services_1 = require("../di/di.services");
/**
 * @stable [18.05.2020]
 * @param {SelectValueT} option
 * @returns {EntityIdT}
 */
var fromSelectValueToId = function (option) {
    if (R.isNil(option)) {
        return option;
    }
    if (type_1.TypeUtils.isPrimitive(option)) {
        return option;
    }
    var optionAsObject = option;
    return optionAsObject.value;
};
/**
 * @stable [18.05.2020]
 * @param {SelectValueT} option
 * @returns {StringNumberT}
 */
var fromSelectValueToDisplayValue = function (option) {
    if (R.isNil(option)) {
        return option;
    }
    if (type_1.TypeUtils.isPrimitive(option)) {
        return option;
    }
    var label = option.label;
    return R.isNil(label)
        ? fromSelectValueToId(option)
        : di_services_1.DiServices.translator()(label, option);
};
/**
 * @stable [18.05.2020]
 */
var SelectOptionUtils = /** @class */ (function () {
    function SelectOptionUtils() {
    }
    SelectOptionUtils.fromSelectValueToDisplayValue = fromSelectValueToDisplayValue; /* @stable [08.07.2020] */
    SelectOptionUtils.fromSelectValueToId = fromSelectValueToId; /* @stable [08.07.2020] */
    return SelectOptionUtils;
}());
exports.SelectOptionUtils = SelectOptionUtils;
//# sourceMappingURL=select-option.js.map