import { IEntity, StringNumberT, AnyT } from '../definitions.interface';
/**
 * @stable [08.11.2019]
 * @param {AnyT} a
 * @param {AnyT} b
 * @returns {number}
 */
export declare const NUMBER_COMPARATOR: (a: AnyT, b: AnyT) => number;
/**
 * @stable [06.09.2020]
 * @param value1
 * @param value2
 */
export declare const VALUE_DESC_SORTER: <TEntity extends IEntity>(value1: StringNumberT, value2: StringNumberT) => number;
/**
 * @stable [08.03.2019]
 * @param {StringNumberT} value1
 * @param {StringNumberT} value2
 * @returns {number}
 */
export declare const VALUE_ASC_SORTER_FN: <TEntity extends IEntity>(value1: StringNumberT, value2: StringNumberT) => number;
/**
 * @stable [29.08.2018]
 * @param {TEntity} item1
 * @param {TEntity} item2
 * @returns {number}
 */
export declare const ID_ASC_ENTITIES_SORTER_FN: <TEntity extends IEntity>(item1: TEntity, item2: TEntity) => number;
/**
 * @stable [13.05.2019]
 * @param {TEntity} item1
 * @param {TEntity} item2
 * @returns {number}
 */
export declare const ID_DESC_ENTITIES_SORTER_FN: <TEntity extends IEntity>(item1: TEntity, item2: TEntity) => number;
/**
 * @stable [16.06.2020]
 */
export declare class SortUtils {
    static readonly NAME_ASC_SORTER: <TEntity extends IEntity>(value1: StringNumberT, value2: StringNumberT) => number;
    static readonly VALUE_DESC_SORTER: <TEntity extends IEntity>(value1: StringNumberT, value2: StringNumberT) => number;
}
