"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SortUtils = exports.ID_DESC_ENTITIES_SORTER_FN = exports.ID_ASC_ENTITIES_SORTER_FN = exports.VALUE_ASC_SORTER_FN = exports.VALUE_DESC_SORTER = exports.NUMBER_COMPARATOR = void 0;
var util_1 = require("../util");
/**
 * @stable [08.11.2019]
 * @param {AnyT} a
 * @param {AnyT} b
 * @returns {number}
 */
exports.NUMBER_COMPARATOR = function (a, b) { return a - b; };
/**
 * @stable [09.04.2019]
 * @param {StringNumberT} value1
 * @param {StringNumberT} value2
 * @returns {number}
 */
var NAME_ASC_SORTER = function (value1, value2) {
    return util_1.nvl("" + value1, '').localeCompare("" + value2);
};
/**
 * @stable [06.09.2020]
 * @param value1
 * @param value2
 */
exports.VALUE_DESC_SORTER = function (value1, value2) {
    return exports.VALUE_ASC_SORTER_FN(value1, value2) * -1;
};
/**
 * @stable [08.03.2019]
 * @param {StringNumberT} value1
 * @param {StringNumberT} value2
 * @returns {number}
 */
exports.VALUE_ASC_SORTER_FN = function (value1, value2) {
    return value1 === value2 ? 0 : exports.NUMBER_COMPARATOR(value1, value2);
};
/**
 * @stable [29.08.2018]
 * @param {TEntity} item1
 * @param {TEntity} item2
 * @returns {number}
 */
exports.ID_ASC_ENTITIES_SORTER_FN = function (item1, item2) {
    return exports.VALUE_ASC_SORTER_FN(item1.id, item2.id);
};
/**
 * @stable [13.05.2019]
 * @param {TEntity} item1
 * @param {TEntity} item2
 * @returns {number}
 */
exports.ID_DESC_ENTITIES_SORTER_FN = function (item1, item2) {
    return exports.VALUE_DESC_SORTER(item1.id, item2.id);
};
/**
 * @stable [16.06.2020]
 */
var SortUtils = /** @class */ (function () {
    function SortUtils() {
    }
    SortUtils.NAME_ASC_SORTER = NAME_ASC_SORTER;
    SortUtils.VALUE_DESC_SORTER = exports.VALUE_DESC_SORTER;
    return SortUtils;
}());
exports.SortUtils = SortUtils;
//# sourceMappingURL=sort.js.map