import { IProgressWrapper } from '../definitions.interface';
export declare class DelayedTask implements IProgressWrapper {
    private readonly task;
    private readonly period;
    private readonly repeat;
    private taskId;
    private context;
    /**
     * @stable [26.09.2020]
     * @param task
     * @param period
     * @param repeat
     */
    constructor(task: (context?: unknown) => void, period?: number, repeat?: boolean);
    /**
     * @stable [26.09.2020]
     */
    get progress(): boolean;
    /**
     * @stable [26.09.2020]
     * @param context
     */
    start<TContext = unknown>(context?: TContext): void;
    /**
     * @stable [26.09.2020]
     * @param context
     */
    startImmediately<TContext = unknown>(context?: TContext): void;
    /**
     * @stable [26.09.2020]
     */
    stop(): void;
    /**
     * @stable [26.09.2020]
     */
    private launchTask;
    /**
     * @stable [26.09.2020]
     */
    private onTaskDone;
    /**
     * @stable [26.09.2020]
     */
    private callTask;
}
