/**
 * @stable [02.10.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
export declare const isDef: (value: unknown) => boolean;
/**
 * @stable [02.10.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
export declare const isFn: (value: unknown) => boolean;
/**
 * @stable [06.12.2018]
 * @param {TResult} result
 * @returns {TResult}
 */
export declare const asType: <TResult>(result: TResult) => TResult;
/**
 * @stable [16.05.2020]
 */
export declare class TypeUtils {
    static readonly asType: <TResult>(result: TResult) => TResult;
    static readonly isBoolean: (value: unknown) => boolean;
    static readonly isDef: (value: unknown) => boolean;
    static readonly isEvent: (v: unknown) => boolean;
    static readonly isFn: (value: unknown) => boolean;
    static readonly isNotEmptyObject: (value: unknown) => boolean;
    static readonly isNotEmptyString: (value: unknown) => boolean;
    static readonly isNotNumber: (value: unknown) => boolean;
    static readonly isNumber: (value: unknown) => boolean;
    static readonly isObject: (v: unknown) => boolean;
    static readonly isPositiveNumber: (value: unknown) => boolean;
    static readonly isPositiveNumberLike: (value: unknown) => boolean;
    static readonly isPositiveOptionalNumberLike: (value: unknown) => boolean;
    static readonly isPositiveOrNegativeNumberLike: (value: unknown) => boolean;
    static readonly isPositiveOrNegativeOptionalNumberLike: (value: unknown) => boolean;
    static readonly isPrimitive: (v: unknown) => boolean;
    static readonly isString: (value: unknown) => boolean;
    static readonly isUndef: (value: unknown) => boolean;
}
